SystemOrganization addCategory: #'Magritte-VerifiedTextInput'!

MATextInputComponent subclass: #MAVerifiedTextInputComponent
	instanceVariableNames: 'verification valueOriginal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-VerifiedTextInput'!

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 3/23/2009 12:24'!
children

	valueOriginal := self model readUsing: self description.
	
	^ super children! !

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 3/24/2009 02:24'!
doValidate

	"no change"
	
	self isReadonly ifTrue: [ ^ self ].
	
	(self value ifNil: ['']) = verification ifFalse: [ MAConditionError description: self description signal: self description kindErrorMessage ].! !

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 9/16/2008 13:00'!
isPassword

	^ self description respondsTo: #isObfuscated:! !

!MAVerifiedTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 9/16/2008 13:03'!
renderEditorOn: html

	self isPassword 
		ifTrue: [ self renderPasswordOn: html ]
		ifFalse: [ self renderTextInputOn: html ]! !

!MAVerifiedTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 3/28/2009 00:23'!
renderPasswordOn: html

	html passwordInput
		class: 'first';
		id: self labelId;
		onFocus: (html formElement select);
		on: #string of: self.

	html passwordInput
		class: 'second';
		id: self labelId, 'b';
		onFocus: (html formElement select);
		on: #verification of: self.
		
	html text: ' (enter twice) '.
		
! !

!MAVerifiedTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 3/29/2009 15:50'!
renderTextInputOn: html

	html textInput
		class: 'first';
		onFocus: (html formElement select);
		id: self labelId;
		on: #string of: self.

	html textInput
		class: 'second';
		id: self labelId, 'b';
		onFocus: (html formElement select);
		on: #verification of: self.
		
	html text: ' (enter twice) '.! !

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 9/16/2008 13:01'!
string

	self isPassword ifFalse: [ ^ super string ].
	
	^ self description obfuscated: self value! !

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 3/25/2009 19:14'!
string: aString

	(self isPassword and: [ self description isObfuscated: aString ])
		ifFalse: [ super string: aString ]! !

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 3/23/2009 12:32'!
verification
	"Answer the value of verification"

	^ verification ifNil: [ verification := self value ]! !

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 3/25/2009 19:14'!
verification: anObject
	"Set the value of verification"

	verification := anObject! !
